unit MotSRec;

interface

function ReadSRec(fn: string; var a: array of byte): integer;

implementation

uses sysutils;

// returns number of bytes read
function ReadSRec(fn: string; var a: array of byte): integer;
var f: TextFile;
    s: string;
    i,j,l: integer;
    c: char;
begin
  if length(fn) = 0 then raise Exception.Create('Filename is empty');
  if low(a) <> 0 then raise Exception.Create('Zero based array expected');
  l := high(a);
  FillChar(a,l+1,$ff);
  i := 0;

  AssignFile(f, fn);
  {$I-}
  Reset(f);
  {$I+}
  if IOResult <> 0 then raise Exception.Create('Could not open ' + fn);
  try
    while not EOF(f) do
    begin
      Readln(f, s);
      if (length(s) < 10)or(length(s) mod 2 <> 0)or(s[1]<>'S') then
        raise Exception.Create('Invalid SHEX file');
      c := s[2];

      case c of
        '1': begin j := 9;  i := strtoint('$' + copy(s,5,4)); end;
        '2': begin j := 11; i := strtoint('$' + copy(s,5,6)); end;
        '3': begin j := 13; i := strtoint('$' + copy(s,5,8)); end;
      else
        continue;
      end;

      for j:=j to (length(s)-2) do
      begin
        if(j mod 2)<>1 then continue;
        if (i > l) then raise Exception.Create('Array too small');
        a[i] := strtoint('$' + Copy(s, j,2));
        inc(i);
      end;

    end;

  finally
    CloseFile(f);
  end;

  Result := i;
end;

end.
